Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftke.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftke.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftke.F90	(revision 3211)
@@ -82,12 +82,25 @@
    REAL(wp) ::   rhftau_scl = 1.0_wp       ! scale factor applied to HF part of taum  (nn_etau=3)
 
+   !! DCSE_NEMO: en is public because it is used by asmtrj
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   en             !: now turbulent kinetic energy   [m2/s2]
    REAL(wp)        , ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   htau           ! depth of tke penetration (nn_htau)
-   REAL(wp)        , ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   dissl          ! now mixing lenght of dissipation
+   REAL(wp)        , ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   dissl          ! now mixing length of dissipation
 #if defined key_c1d
    !                                                                        !!** 1D cfg only  **   ('key_c1d')
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   e_dis, e_mix   !: dissipation and mixing turbulent lengh scales
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   e_pdl, e_ric   !: prandl and local Richardson numbers
-#endif
+   !! DCSE_NEMO: these arrays do not need to be public
+!  REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   e_dis, e_mix   !: dissipation and mixing turbulent length scales
+!  REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   e_pdl, e_ric   !: prandl and local Richardson numbers
+   REAL(wp),         ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   e_dis, e_mix   !: dissipation and mixing turbulent length scales
+   REAL(wp),         ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   e_pdl, e_ric   !: prandl and local Richardson numbers
+#endif
+
+   !! * Control permutation of array indices
+#  include "zdftke_ftrans.h90"
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "domvvl_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+!FTRANS dissl e_dis e_mix e_pdl e_ric :I :I :z
 
    !! * Substitutions
@@ -195,4 +208,8 @@
       USE wrk_nemo, ONLY:   zhlc  =>  wrk_2d_1   ! 2D REAL workspace
       USE wrk_nemo, ONLY:   zpelc =>  wrk_3d_1   ! 3D REAL workspace
+
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zdiag zd_up zd_lw :I :I :z
+!FTRANS zpelc :I :I :z
       !
       INTEGER  ::   ji, jj, jk                      ! dummy loop arguments
@@ -226,5 +243,9 @@
       DO jj = 2, jpjm1            ! en(1)   = rn_ebb taum / rau0  (min value rn_emin0)
          DO ji = fs_2, fs_jpim1   ! vector opt.
+#if defined key_z_first
+            en(ji,jj,1) = MAX( rn_emin0, zbbrau * taum(ji,jj) ) * tmask_1(ji,jj)
+#else
             en(ji,jj,1) = MAX( rn_emin0, zbbrau * taum(ji,jj) ) * tmask(ji,jj,1)
+#endif
          END DO
       END DO
@@ -260,15 +281,33 @@
          !
          !                        !* total energy produce by LC : cumulative sum over jk
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               zpelc(ji,jj,1) =  MAX( rn2b(ji,jj,1), 0._wp ) * fsdepw(ji,jj,1) * fse3w(ji,jj,1)
+               DO jk = 2, jpk
+                  zpelc(ji,jj,jk)  = zpelc(ji,jj,jk-1) + MAX( rn2b(ji,jj,jk), 0._wp ) * fsdepw(ji,jj,jk) * fse3w(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+#else
          zpelc(:,:,1) =  MAX( rn2b(:,:,1), 0._wp ) * fsdepw(:,:,1) * fse3w(:,:,1)
          DO jk = 2, jpk
             zpelc(:,:,jk)  = zpelc(:,:,jk-1) + MAX( rn2b(:,:,jk), 0._wp ) * fsdepw(:,:,jk) * fse3w(:,:,jk)
          END DO
+#endif
          !                        !* finite Langmuir Circulation depth
          zcof = 0.5 * 0.016 * 0.016 / ( zrhoa * zcdrag )
          imlc(:,:) = mbkt(:,:) + 1       ! Initialization to the number of w ocean point (=2 over land)
+#if defined key_z_first
+         DO jj = 1, jpj                  ! Last w-level at which zpelc>=0.5*us*us 
+            DO ji = 1, jpi               !      with us=0.016*wind(starting from jpk-1)
+               zus  = zcof * taum(ji,jj)
+               DO jk = jpkm1, 2, -1
+#else
          DO jk = jpkm1, 2, -1
             DO jj = 1, jpj               ! Last w-level at which zpelc>=0.5*us*us 
                DO ji = 1, jpi            !      with us=0.016*wind(starting from jpk-1)
                   zus  = zcof * taum(ji,jj)
+#endif
                   IF( zpelc(ji,jj,jk) > zus )   imlc(ji,jj) = jk
                END DO
@@ -287,4 +326,10 @@
          END DO
          zcof = 0.016 / SQRT( zrhoa * zcdrag )
+#if defined key_z_first
+         DO jj = 2, jpjm1         !* TKE Langmuir circulation source term added to en
+            DO ji = 2, jpim1
+               zus  = zcof * SQRT( taum(ji,jj) )           ! Stokes drift
+               DO jk = 2, jpkm1
+#else
 !CDIR NOVERRCHK
          DO jk = 2, jpkm1         !* TKE Langmuir circulation source term added to en
@@ -294,4 +339,5 @@
                DO ji = fs_2, fs_jpim1   ! vector opt.
                   zus  = zcof * SQRT( taum(ji,jj) )           ! Stokes drift
+#endif
                   !                                           ! vertical velocity due to LC
                   zind = 0.5 - SIGN( 0.5, fsdepw(ji,jj,jk) - zhlc(ji,jj) )
@@ -312,7 +358,15 @@
       !                     ! zdiag : diagonal zd_up : upper diagonal zd_lw : lower diagonal
       !
+#if defined key_z_first
+      !* Shear production at uw- and vw-points (energy conserving form)
+             ! here avmu, avmv used as workspace
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            DO jk = 2, jpkm1
+#else
       DO jk = 2, jpkm1           !* Shear production at uw- and vw-points (energy conserving form)
          DO jj = 1, jpj                 ! here avmu, avmv used as workspace
             DO ji = 1, jpi
+#endif
                avmu(ji,jj,jk) = avmu(ji,jj,jk) * ( un(ji,jj,jk-1) - un(ji,jj,jk) )   &
                   &                            * ( ub(ji,jj,jk-1) - ub(ji,jj,jk) )   & 
@@ -326,8 +380,15 @@
          END DO
       END DO
-      !
+
+      !
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 2, jpkm1     !* Matrix and right hand side in en
+#else
       DO jk = 2, jpkm1           !* Matrix and right hand side in en
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                zcof   = zfact1 * tmask(ji,jj,jk)
                zzd_up = zcof * ( avm  (ji,jj,jk+1) + avm  (ji,jj,jk  ) )   &  ! upper diagonal
@@ -350,4 +411,27 @@
       END DO
       !                          !* Matrix inversion from level 2 (tke prescribed at level 1)
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            ! First recurrence : Dk = Dk - Lk * Uk-1 / Dk-1
+            DO jk = 3, jpkm1
+               zdiag(ji,jj,jk) = zdiag(ji,jj,jk) - zd_lw(ji,jj,jk) * zd_up(ji,jj,jk-1) / zdiag(ji,jj,jk-1)
+            END DO
+            ! Second recurrence : Lk = RHSk - Lk / Dk-1 * Lk-1
+            zd_lw(ji,jj,2) = en(ji,jj,2) - zd_lw(ji,jj,2) * en(ji,jj,1)    ! Surface boudary conditions on tke
+            DO jk = 3, jpkm1
+               zd_lw(ji,jj,jk) = en(ji,jj,jk) - zd_lw(ji,jj,jk) / zdiag(ji,jj,jk-1) *zd_lw(ji,jj,jk-1)
+            END DO
+            ! Third recurrence : Ek = ( Lk - Uk * Ek+1 ) / Dk
+            en(ji,jj,jpkm1) = zd_lw(ji,jj,jpkm1) / zdiag(ji,jj,jpkm1)
+            DO jk = jpk-2, 2, -1
+               en(ji,jj,jk) = ( zd_lw(ji,jj,jk) - zd_up(ji,jj,jk) * en(ji,jj,jk+1) ) / zdiag(ji,jj,jk)
+            END DO
+            DO jk = 2, jpkm1                       ! set the minimum value of tke
+               en(ji,jj,jk) = MAX( en(ji,jj,jk), rn_emin ) * tmask(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+#else
       DO jk = 3, jpkm1                             ! First recurrence : Dk = Dk - Lk * Uk-1 / Dk-1
          DO jj = 2, jpjm1
@@ -388,4 +472,5 @@
          END DO
       END DO
+#endif
 
       !                            !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
@@ -393,7 +478,13 @@
       !                            !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       IF( nn_etau == 1 ) THEN           !* penetration below the mixed layer (rn_efr fraction)
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 2, jpkm1
+#else
          DO jk = 2, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   en(ji,jj,jk) = en(ji,jj,jk) + rn_efr * en(ji,jj,1) * EXP( -fsdepw(ji,jj,jk) / htau(ji,jj) )   &
                      &                                               * ( 1._wp - fr_i(ji,jj) )  * tmask(ji,jj,jk)
@@ -410,4 +501,7 @@
          END DO
       ELSEIF( nn_etau == 3 ) THEN       !* penetration belox the mixed layer (HF variability)
+
+         !! DCSE_NEMO: its probably not worth changing the order of these loops for level first indexing,
+         !!            unless we also make zdif a 2-d (jpi,jpj) array
 !CDIR NOVERRCHK
          DO jk = 2, jpkm1
@@ -435,4 +529,12 @@
    END SUBROUTINE tke_tke
 
+   !! * Reset control of array index permutation
+#  include "zdftke_ftrans.h90"
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "domvvl_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+!FTRANS dissl e_dis e_mix e_pdl e_ric :I :I :z
 
    SUBROUTINE tke_avn
@@ -472,4 +574,6 @@
       !!----------------------------------------------------------------------
       USE oce, ONLY:   zmpdl => ua , zmxlm => va , zmxld => ta   ! (ua,va,ta) used as workspace
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zmpdl zmxlm zmxld :I :I :z
       !!
       INTEGER  ::   ji, jj, jk   ! dummy loop indices
@@ -491,5 +595,12 @@
          zmxlm(:,:,1) = rn_mxl0
       ENDIF
-      zmxlm(:,:,jpk)  = rmxl_min     ! last level set to the interior minium value
+
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            zmxlm(ji,jj,jpk) = rmxl_min     ! last level set to the interior minium value
+            DO jk = 2, jpkm1        ! interior value : l=sqrt(2*e/n^2)
+#else
+      zmxlm(:,:,jpk)  = rmxl_min    ! last level set to the interior minium value
       !
 !CDIR NOVERRCHK
@@ -499,4 +610,5 @@
 !CDIR NOVERRCHK
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                zrn2 = MAX( rn2(ji,jj,jk), rsmall )
                zmxlm(ji,jj,jk) = MAX(  rmxl_min,  SQRT( 2._wp * en(ji,jj,jk) / zrn2 )  )
@@ -513,7 +625,13 @@
       !
       CASE ( 0 )           ! bounded by the distance to surface and bottom
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 2, jpkm1
+#else
          DO jk = 2, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   zemxl = MIN( fsdepw(ji,jj,jk), zmxlm(ji,jj,jk),   &
                   &            fsdepw(ji,jj,mbkt(ji,jj)+1) - fsdepw(ji,jj,jk) )
@@ -525,7 +643,13 @@
          !
       CASE ( 1 )           ! bounded by the vertical scale factor
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 2, jpkm1
+#else
          DO jk = 2, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   zemxl = MIN( fse3w(ji,jj,jk), zmxlm(ji,jj,jk) )
                   zmxlm(ji,jj,jk) = zemxl
@@ -536,4 +660,18 @@
          !
       CASE ( 2 )           ! |dk[xml]| bounded by e3t :
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 2, jpkm1   ! from the surface to the bottom :
+                  zmxlm(ji,jj,jk) = MIN( zmxlm(ji,jj,jk-1) + fse3t(ji,jj,jk-1), zmxlm(ji,jj,jk) )
+               END DO
+               DO jk = jpkm1, 2, -1     ! from the bottom to the surface :
+                  zemxl = MIN( zmxlm(ji,jj,jk+1) + fse3t(ji,jj,jk+1), zmxlm(ji,jj,jk) )
+                  zmxlm(ji,jj,jk) = zemxl
+                  zmxld(ji,jj,jk) = zemxl
+               END DO
+            END DO
+         END DO
+#else
          DO jk = 2, jpkm1         ! from the surface to the bottom :
             DO jj = 2, jpjm1
@@ -552,6 +690,25 @@
             END DO
          END DO
+#endif
          !
       CASE ( 3 )           ! lup and ldown, |dk[xml]| bounded by e3t :
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 2, jpkm1         ! from the surface to the bottom : lup
+                  zmxld(ji,jj,jk) = MIN( zmxld(ji,jj,jk-1) + fse3t(ji,jj,jk-1), zmxlm(ji,jj,jk) )
+               END DO
+               DO jk = jpkm1, 2, -1     ! from the bottom to the surface : ldown
+                  zmxlm(ji,jj,jk) = MIN( zmxlm(ji,jj,jk+1) + fse3t(ji,jj,jk+1), zmxlm(ji,jj,jk) )
+               END DO
+               DO jk = 2, jpkm1
+                  zemlm = MIN ( zmxld(ji,jj,jk),  zmxlm(ji,jj,jk) )
+                  zemlp = SQRT( zmxld(ji,jj,jk) * zmxlm(ji,jj,jk) )
+                  zmxlm(ji,jj,jk) = zemlm
+                  zmxld(ji,jj,jk) = zemlp
+               END DO
+            END DO
+         END DO
+#else
          DO jk = 2, jpkm1         ! from the surface to the bottom : lup
             DO jj = 2, jpjm1
@@ -581,4 +738,5 @@
             END DO
          END DO
+#endif
          !
       END SELECT
@@ -592,4 +750,9 @@
       !                     !  Vertical eddy viscosity and diffusivity  (avmu, avmv, avt)
       !                     !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 1, jpkm1      !* vertical eddy viscosity & diffivity at w-points
+#else
 !CDIR NOVERRCHK
       DO jk = 1, jpkm1            !* vertical eddy viscosity & diffivity at w-points
@@ -598,4 +761,5 @@
 !CDIR NOVERRCHK
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                zsqen = SQRT( en(ji,jj,jk) )
                zav   = rn_ediff * zmxlm(ji,jj,jk) * zsqen
@@ -608,7 +772,13 @@
       CALL lbc_lnk( avm, 'W', 1. )      ! Lateral boundary conditions (sign unchanged)
       !
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 2, jpkm1      !* vertical eddy viscosity at u- and v-points
+#else
       DO jk = 2, jpkm1            !* vertical eddy viscosity at u- and v-points
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                avmu(ji,jj,jk) = 0.5 * ( avm(ji,jj,jk) + avm(ji+1,jj  ,jk) ) * umask(ji,jj,jk)
                avmv(ji,jj,jk) = 0.5 * ( avm(ji,jj,jk) + avm(ji  ,jj+1,jk) ) * vmask(ji,jj,jk)
@@ -619,7 +789,13 @@
       !
       IF( nn_pdl == 1 ) THEN      !* Prandtl number case: update avt
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 2, jpkm1
+#else
          DO jk = 2, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   zcoef = avm(ji,jj,jk) * 2._wp * fse3w(ji,jj,jk) * fse3w(ji,jj,jk)
                   !                                          ! shear
@@ -652,4 +828,12 @@
    END SUBROUTINE tke_avn
 
+   !! * Reset control of array index permutation
+#  include "zdftke_ftrans.h90"
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "domvvl_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+!FTRANS dissl e_dis e_mix e_pdl e_ric :I :I :z
 
    SUBROUTINE zdf_tke_init
@@ -733,4 +917,14 @@
       ENDIF
       !                               !* set vertical eddy coef. to the background value
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+             avt (ji,jj,:) = avtb(:) * tmask(ji,jj,:)
+             avm (ji,jj,:) = avmb(:) * tmask(ji,jj,:)
+             avmu(ji,jj,:) = avmb(:) * umask(ji,jj,:)
+             avmv(ji,jj,:) = avmb(:) * vmask(ji,jj,:)
+         END DO
+      END DO
+#else
       DO jk = 1, jpk
          avt (:,:,jk) = avtb(jk) * tmask(:,:,jk)
@@ -739,4 +933,5 @@
          avmv(:,:,jk) = avmb(jk) * vmask(:,:,jk)
       END DO
+#endif
       dissl(:,:,:) = 1.e-12_wp
       !                              
@@ -759,5 +954,5 @@
      CHARACTER(len=*), INTENT(in) ::   cdrw   ! "READ"/"WRITE" flag
      !
-     INTEGER ::   jit, jk   ! dummy loop indices
+     INTEGER ::   jit, ji, jj, jk   ! dummy loop indices
      INTEGER ::   id1, id2, id3, id4, id5, id6   ! local integers
      !!----------------------------------------------------------------------
@@ -792,4 +987,14 @@
         ELSE                                   !* Start from rest
            en(:,:,:) = rn_emin * tmask(:,:,:)
+#if defined key_z_first
+           DO jj = 1, jpj                           ! set the Kz to the background value
+              DO ji = 1, jpi
+                  avt (ji,jj,:) = avtb(:) * tmask(ji,jj,:)
+                  avm (ji,jj,:) = avmb(:) * tmask(ji,jj,:)
+                  avmu(ji,jj,:) = avmb(:) * umask(ji,jj,:)
+                  avmv(ji,jj,:) = avmb(:) * vmask(ji,jj,:)
+              END DO
+           END DO
+#else
            DO jk = 1, jpk                           ! set the Kz to the background value
               avt (:,:,jk) = avtb(jk) * tmask(:,:,jk)
@@ -798,4 +1003,6 @@
               avmv(:,:,jk) = avmb(jk) * vmask(:,:,jk)
            END DO
+#endif
+
         ENDIF
         !
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftke_ftrans.h90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftke_ftrans.h90	(revision 3211)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftke_ftrans.h90	(revision 3211)
@@ -0,0 +1,20 @@
+   !!----------------------------------------------------------------------
+   !!                   ***  zdftke_ftrans  ***
+   !!----------------------------------------------------------------------
+   !! ** purpose : Directives to control permutation of array indices for
+   !!   public multi-dimensional arrays with a z-dimension declared in module
+   !!   zdftke.  It should be included wherever the module is used,
+   !!   and updated whenever a new public array is added to the module.
+   !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2011)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+#if defined key_z_first
+!FTRANS assert :z :I
+#else
+!FTRANS assert :I :z
+#endif
+!FTRANS en :I :I :z
